BL <-
function(haplos.list, baseline = "missing",a = 20, b = 20, start.beta = 0.01, lambda = 1, D = 0, seed = NULL, e = 0.1, burn.in = 20000, num.it = 50000) 
{
    if (is.null(seed)==FALSE) set.seed(seed)
    haplos.names <- names(haplos.list$initFreq)
    freq <- haplos.list$initFreq
    if (baseline=="missing")
    {
      baseline <- haplos.names[which.max(freq)]
    }
    column.subset <- colnames(haplos.list$haploDM) != baseline
    hdat <- cbind(haplos.list$nonHaploDM, haplos.list$haploDM[, column.subset])
    colnames(hdat) <- c(colnames(haplos.list$nonHaploDM), colnames(haplos.list$haploDM[, column.subset]))
    ID <- haplos.list$ID
    N <- sum(haplos.list$wt)
    y <- as.numeric(hdat[, 1])
    x <- data.matrix(hdat[, -1])
    colnames(x)<-NULL

    freq.new<-freq[names(haplos.list$haploDM[, column.subset])]
    freq.new[length(freq.new)+1]<-freq[baseline]
    freq.new<-as.vector(freq.new)
    num.haplo.id<-as.vector(table(ID))
    x.length<-as.integer(dim(x)[2])
    unique.x<-unique(x)	

    beta=rep(start.beta, x.length)
    beta.out<-numeric((num.it-burn.in)*x.length)
    lambda.out<-numeric(num.it-burn.in)
    freq.out<-numeric((num.it-burn.in)*(x.length+1))
    D.out<-numeric(num.it-burn.in)

    #dyn.load("BL.so")
    
    out<-.C("mcmc", x=as.integer(x), n=as.integer(dim(x)[1]), as.integer(y), as.integer(N), as.integer(num.haplo.id), as.integer(x.length), as.double(freq.new), as.double(D), as.double(beta), as.double(a), as.double(b), as.integer(t(unique.x)), as.integer(dim(unique.x)[1]), as.double(lambda), as.integer(num.it), as.integer(burn.in), beta.out=as.double(beta.out), lambda.out=as.double(lambda.out), freq.out=as.double(freq.out), D.out=as.double(D.out))

    beta.out<-matrix(out$beta.out,nrow=num.it-burn.in, byrow=TRUE)
    freq.out<-matrix(out$freq.out,nrow=num.it-burn.in, byrow=TRUE)

    ci.beta<-numeric(x.length*2)
    ci.lambda<-numeric(2)
    ci.D<-numeric(2)
    post.mean.beta<-numeric(x.length)
    ci.freq<-numeric((x.length+1)*2)
	post.mean.freq<-numeric(x.length+1) 
    k<-1
    for (i in 1:x.length)
      {
        ci.beta[k]<-quantile(beta.out[,i], probs=0.025)
        ci.beta[k+1]<-quantile(beta.out[,i], probs=0.975)
        k<-k+2
        post.mean.beta[i]<- mean(beta.out[,i])
      }
    
    ci.lambda<-c(quantile(out$lambda.out, probs=0.025),quantile(out$lambda.out, probs=0.975))
    ci.D<-c(quantile(out$D.out, probs=0.025),quantile(out$D.out, probs=0.975))

    k<-1
    for (i in 1:(x.length+1))
      {
        ci.freq[k]<-quantile(freq.out[,i], probs=0.025)
        ci.freq[k+1]<-quantile(freq.out[,i], probs=0.975)
        k<-k+2
	post.mean.freq[i]<- mean(freq.out[,i])
      } 

    prob.alt<-numeric(x.length)
    BF<-numeric(x.length)
    
    for (i in 1:x.length)
      {
        prob.alt[i]<-length(beta.out[,i][abs(beta.out[,i]) > e])/(num.it-burn.in)
      }

    for (i in 1:x.length)
      {
        prior.prob<-(b/(e+b))^a
        if (prob.alt[i]<1) 
          {
            BF[i]<-(prob.alt[i]/(1-prob.alt[i]))/(prior.prob/(1-prior.prob))
            #BF[i]<-round(BF[i],8)
          } else
        BF[i]<-">100"
      }

    names(BF)<-colnames(hdat[, -1])
    names(post.mean.beta)<-colnames(hdat[, -1])

    ci.beta<-matrix(ci.beta,nrow=x.length, ncol=2, byrow=TRUE)
    ci.beta<-data.frame(colnames(hdat[, -1]),exp(ci.beta))
    colnames(ci.beta)<-c("Hap", "Lower", "Upper")

    ci.freq<-matrix(ci.freq,nrow=(x.length+1), ncol=2, byrow=TRUE)
    ci.freq<-data.frame(c(colnames(hdat[, -1]),baseline), ci.freq)
    colnames(ci.freq)<-c("Hap", "Lower", "Upper")
	names(post.mean.freq)<-c(colnames(hdat[, -1]), baseline)
    ans <- list(BF = BF, OR = exp(post.mean.beta), CI.OR = ci.beta, freq=post.mean.freq, CI.freq = ci.freq, CI.lambda = ci.lambda, CI.D = ci.D)
    return(ans)
}
